function [B, u, u_boot] = BootaBoot_1( B1, X, Y,rplusM,T,p,XXX)

% first step pf Kilians Bootstrap after Bootstrap procedure. This first
% part removes small sample bias from estimated coefficients

Yhat = X*B1;
u = Y-Yhat;

bias = [];
nboot = 500;
for m = 1:nboot  
    c = ceil(rand(T-p,1)*(T-p));
    u_boot = u(c,:);
    Xpast_boot = [];
    for i = p:-1:1
        Xpast_boot = [Xpast_boot XXX(i,:)]; %eigentlich Anfangswerte randomisieren
    end
    Xpast_boot = [Xpast_boot 1];
    
    X_boot = XXX;
    for t = p+1:T
       X_boot(t,:) = Xpast_boot*B1 + u_boot(t-p,:);       
           Xpast_boot = [X_boot(t,:) Xpast_boot(:,1:end-rplusM-1) 1];
    end   
    
    z = X_boot;    
        clear X_boot; clear Xpast_boot;
    zpast = [];
    for kk = 1:p
        zpast = [zpast z(p-kk+1:end-kk,:)]; 
    end;
    zcurr = z(p+1:end,:);
    zpast = [zpast ones(T-p,1)];
    
    B_boot = inv(zpast'*zpast)*zpast'*zcurr;  
    bias(:,:,m) = B1 - B_boot; %rplusM+1 x rplusM x nboot
end
Bcorr = B1 - mean(bias,3);

% Computing Residual

z = XXX;    
zpast = [];
for kk = 1:p
    zpast = [zpast XXX(p-kk+1:end-kk,:)]; 
end;
zcurr = z(p+1:end,:);
zpast = [zpast ones(T-p,1)];
u = zcurr - zpast*Bcorr;
clear zcurr zpast;

B = Bcorr;
