
%% estimate a VAR with median banks instead of Factor from micro level
% variables

clear all
rand('state',56);
randn('seed',3);
load IMP1_cum_FullModel


ImpactsupGDP = IMP1_cum(1,1,1);
ImpactdemGDP = IMP1_cum(2,1,1);
ImpacthpHP=IMP1_cum(3,3,1);
ImpactmpMP=IMP1_cum(10,10,1);% it enters being an expans. shock. here we want to have contr. mp shock
clear IMP1_cum
remove = 1;
Vars = 5;
p = 1;
rplusM = 5+4;
CI = 0.90;

load('MacroData.txt');
OBS = MacroData;


load('BankData.txt');

[MM,WW,Xqoq] = transfstandard(BankData); % standardizing variables

 if Vars == 5
    Meds = Xqoq(:,1:5)*WW(1:5,1:5);
 end
 
 %% Step 1: Fit VAR model to median variables and to obs and compute IRFs
 XXX = [OBS(:,1) OBS(:,2) OBS(:,3) Meds OBS(:,4)];
%XXX = [gdp def hp Meds ffr(2:end,:)];
[T N] = size(XXX);

%% Estimating Matrix Of Coefficiencts B
% generate the matrix of variables
clear L c cc h i ic nor r x 
% generating matrix of RHS ( in companion form if necessary)
regr = [];
for i = 0:p-1
    regr = [regr XXX(p-i:end-i-1,:)];
end
X = regr;
% generate trend variable and add together with a constant to matrix of RHS

X = [X ones(length(X),1)]; % X plus deterministic components

% generate matrix of LHS
Y = XXX(p+1:end,:);
clear regr 

%% OLS estimator for the VAR system
B1 = inv(X'*X)*(X'*Y);


%% Step 2: retrieve cholestky residuals and...
% Computing Residual
Yhat = X*B1;
u = Y-Yhat;

bias = [];
nboot = 500;
[M] = size(B1,2);
for m = 1:nboot  
    m;
    c = ceil(rand(T-p,1)*(T-p));
    u_boot = u(c,:);
    Xpast_boot = [];
    for i = p:-1:1
        Xpast_boot = [Xpast_boot XXX(i,:)]; %eigentlich Anfangswerte randomisieren
    end
    Xpast_boot = [Xpast_boot 1];
    
    X_boot = XXX;
    for t = p+1:T
       X_boot(t,:) = Xpast_boot*B1 + u_boot(t-p,:);       
           Xpast_boot = [X_boot(t,:) Xpast_boot(:,1:end-M-1) 1];
    end   
    
    z = X_boot;    
        clear X_boot; clear Xpast_boot;
    zpast = [];
    for kk = 1:p
        zpast = [zpast z(p-kk+1:end-kk,:)]; 
    end;
    zcurr = z(p+1:end,:);
    zpast = [zpast ones(T-p,1)];
    
    B_boot = inv(zpast'*zpast)*zpast'*zcurr;  
    bias(:,:,m) = B1 - B_boot; %rplusM+1 x rplusM x nboot
end
Bcorr = B1 - mean(bias,3);
clear bias B1 B_boot z zpast zcurr;

%% now we need to identify the structural shocks
% Computing Residual

z = XXX;    
zpast = [];
for kk = 1:p
    zpast = [zpast XXX(p-kk+1:end-kk,:)]; 
end;
zcurr = z(p+1:end,:);
zpast = [zpast ones(T-p,1)];
u = zcurr - zpast*Bcorr;
clear zcurr zpast;

B = Bcorr;
%% Generating VCV Matrix Of Errors
sig = cov(u);
% Generating Chol Residuals
D = chol(sig)';
%normalize shocks to equation explaining federal funds rate to be
%expansionary
D(:,rplusM) = -D(:,rplusM);

% Making VAR Estimates conformable for the impulse reponses 
% concentrate on the coefficients for the covariates. 
% drop the deterministic coimponents

[M] = size(B,2);
%% Step 3: identify structural shocks via sign restrictions and compute IRF
% some variables to be set    
    s = 20; %the horizon
    j = 0;
    t = 0;
    mm = 100; % we keep 100 draws which satify the sign restrictions (see appendix)
    tic;
    while j < mm
    t = t+1;
% set up Q matrix for sign restriction identification (see Rubio-Ramirez et al (2010 for details)
    MM = 2;
    clear Q;
   % make QR decomposition of any  MM x MM matrix consisting of i.i.d
   % Normal varaibles
   Q = eye(MM);
   newmatrix=normrnd(0,1,MM,MM);
   [Q,R]=qr(newmatrix);
   % noralize matrix if loadings is negative
   for i=1:MM;
       if R(i,i)<0
           Q(:,i)=-Q(:,i);
       end
   end

%% generate orthogonalized impulses using cholesky decomposition
% 1. generate the  colesky decomposition
    %generating the correct Q matrix
    HHH = eye(rplusM);
    HHH(1:2,1:2) = Q;
    Q = HHH;
    clear HHH;
    QQ = Q';
    A = D*QQ'; % recall D is the matrix of cholesky residuals
              % this setup creates a matrix A for which A*A' = sig ,i.e.
              % cov(u)
              % so hence the matrix Q' is an admissable rotation
              % candidate! Additionally Q*Q' = (Q')'*Q' = I (unity) so I am
              

% 2. generate the impulse response functions
% first generate the correct parameter matrix we need block

I = eye(M*p,M*p);
BBB = [B(1:M*p,:)';I(1:end-M,:)]; %companion form of B
temp= eye(size(BBB));       
irftemp = [];
irftemp(:,:,1) = temp;
for h = 1:s % generating the VMA terms
   temp = BBB*temp; 
   irftemp(:,:,h+1) = temp;
end; 

%rescale impact matrix
% 
%         A(:,1) = (A(:,1)./A(1,1)).*ImpactsupGDP;
%         A(:,2) = (A(:,2)./A(1,2)).*ImpactdemGDP;
%         A(:,3) = (A(:,3)./A(3,3)).*ImpacthpHP;
%         A(:,rplusM) = (A(:,rplusM)./A(rplusM,rplusM)).*ImpactmpMP;
%         
imp = [];
imp1 = [];
for h = 0:s
    BB = irftemp(1:M,1:M,h+1)'; %B^h 
    imp(:,:,h+1)  = A'*BB; %here use the VMA terms to compute the IRFs
end;

%% generating the correct (cummulated) impulse responses

jj = [1 2 3 7]; % variables in differences (i.e. gdp, def, hp, loans)
for k = 1:4
    kkk = jj(k);
    for jjj = 1:M
        imp1(jjj,kkk,:) = cumsum(imp(jjj,kkk,:));
    end
end

jj = [4 5 6 8 9]; % variables in levels
for k = 1:5
    kkk = jj(k);
    for jjj = 1:M
        imp1(jjj,kkk,:) = (imp(jjj,kkk,:));
    end
end


%% now check the signs of the impulse responses
        %% 1. restrictions on the effects of the supply shock
        a1 = [(((imp1(1,1,1:5)) >= 0)) .* (imp1(1,2,1:5) <= 0) ];
        if max(a1) == 0
                 continue;   %The restrictions are not satisfied.  Go the beginning to redraw.
        elseif (min(a1)==0)
            continue;    %The restrictions are not satisfied.  Go the beginning to redraw.
        end
        %% 2. restrictions on the effects of the demand shock
        a2 = [(((imp1(2,1,1:5)) >= 0)) .* (imp1(2,2,1:5) >= 0).*(imp1(2,rplusM,1:5) >= 0)];
        if max(a2) == 0
                 continue;   %The restrictions are not satisfied.  Go the beginning to redraw.
        elseif (min(a2)==0)
            continue;    %The restrictions are not satisfied.  Go the beginning to redraw.
        end
    j = j+1;
    IMP(:,:,:,j) = imp1; % saves the cummulated IRF
    IMP_nocum(:,:,:,j) = imp; % saves the uncummulated IRF
    QQQ(:,:,j) = QQ; % save the matrix of shocks
    clear imp imp1 Q
    end
    toc
  
    %% calcuate the median values of all the impulse responses which passed
    for i = 1:M
        for k = 1:M
            for j = 1:s
                IMP1(i,k,j) = median(IMP(i,k,j,:));
                IMP_uncum(i,k,j) = median(IMP_nocum(i,k,j,:));
                IMP_std(i,k,j) = std(IMP_nocum(i,k,j,:));
            end
        end
    end
    nrest = 2;
    horrest = 5;

    [I pf] = paganfry2(IMP_nocum,IMP_uncum,IMP_std,M,mm,nrest,horrest);
    %[I pf] = paganfry(IMP_nocum,IMP_uncum,IMP_std);
    % extract the QQ matrix
    Q = QQQ(:,:,I);
    MEDIANPLOT = IMP(:,:,:,I);
    
     Ahelp = (D*Q');
     AhelpTmp = Ahelp;
     %rescale matrix such that shocks are comparable
%rescale impact matrix

        AhelpTmp(:,1) = (Ahelp(:,1)./Ahelp(1,1)).*ImpactsupGDP;
        AhelpTmp(:,2) = (Ahelp(:,2)./Ahelp(1,2)).*ImpactdemGDP;
        AhelpTmp(:,3) = (Ahelp(:,3)./Ahelp(3,3)).*ImpacthpHP;
        AhelpTmp(:,rplusM) = (Ahelp(:,rplusM)./Ahelp(rplusM,rplusM)).*ImpactmpMP;
        %
     u_struct = u*inv(AhelpTmp)';
    
    save u_struct_VAR u_struct
    clear IMP*

    %% Step 4: Bootstrap 
    %with the unique Q (rotatin) matrix use this to bootstrapp
    [M] = size(B,2);
irf_boot = []; u_struct_boot = []; B_boot = []; fe = []; irf0_boot = []; 
fetemp = 0; m = 0; mm = 0; nboot = 500;

irf1 = []; irf2 = []; 
while mm < nboot
    mm;
    c = ceil(rand(T-p,1)*(T-p));
    u_boot = u(c,:);
    Xpast_boot = [];
   
    for i=p:-1:1
        Xpast_boot=[Xpast_boot XXX(i,:)];%eigentlich Anfangswerte randomisieren
    end
    Xpast_boot = [Xpast_boot 1];
    X_boot = XXX;
    for t = p+1:T
       X_boot(t,:) = Xpast_boot*B + u_boot(t-p,:);       
       Xpast_boot = [X_boot(t,:) Xpast_boot(:,1:end-M-1) ones(1,1) ];
    end

        z = X_boot;
            clear X_boot; clear Xpast_boot;
        
        zpast = [];
        for kk = 1:p
            zpast = [zpast z(p-kk+1:end-kk,:)]; 
        end;
        zcurr = z(p+1:end,:);
        zpast = [zpast ones(T-p,1)];

        B_boot = inv(zpast'*zpast)*zpast'*zcurr;  
        u_boot = zcurr  - zpast*B_boot; 
            clear zcurr; clear zpast;
    H = cov(u_boot); 
    D = chol(H)'; 
    D(:,rplusM) = -D(:,rplusM);
    Atilda = D*Q'; % this is the shock which satifies all sign restrictions
    u_orth_boot = u_boot * inv(Atilda)';     

    I = eye(M*p,M*p);
    BBB = [B_boot(1:M*p,:)';I(1:end-M,:)];
    temp = eye(size(BBB));

    irftemp = [];
    irftemp(:,:,1) = temp;
    for h = 1:s
        temp = BBB*temp; 
        irftemp(:,:,h+1) = temp;
    end; 
    clear temp;
    %rescale matrix such that shocks are comparable
%rescale impact matrix

        Atilda(:,1) = (Atilda(:,1)./Atilda(1,1)).*ImpactsupGDP;
        Atilda(:,2) = (Atilda(:,2)./Atilda(1,2)).*ImpactdemGDP;
        Atilda(:,3) = (Atilda(:,3)./Atilda(3,3)).*ImpacthpHP;
        Atilda(:,rplusM) = (Atilda(:,rplusM)./Atilda(rplusM,rplusM)).*ImpactmpMP;
%
u_orth_boot = u_boot * inv(Atilda)';     

    irf0_boottmp = []; irf1_boottmp = []; 
        for h = 0:s
        BB = irftemp(1:M,1:M,h+1)'; %B^h
        irf0_boottmp(:,:,h+1) = Atilda'*BB; %rplusM x rplusM
        end
    clear temp; 
    
 %% now check the signs of the impulse responses
 % step1:% generating the correct (cummulated) impulse responses

jj = [1 2 3 7]; % variables in differences
for k = 1:4
    kkk = jj(k);
    for jjj = 1:M
        imp1(jjj,kkk,:) = cumsum(irf0_boottmp(jjj,kkk,:));
    end
end

jj = [4 5 6 8 9]; % variables in levels
for k = 1:5
    kkk = jj(k);
    for jjj = 1:M
        imp1(jjj,kkk,:) = (irf0_boottmp(jjj,kkk,:));
    end
end       
 
 %% 1. restrictions on the effects of the supply shock
        a1 = [(((imp1(1,1,1:5)) >= 0)) .* (imp1(1,2,1:5) <= 0) ];
        if max(a1) == 0
                 continue;   %The restrictions are not satisfied.  Go the beginning to redraw.
        elseif (min(a1)==0)
            continue;    %The restrictions are not satisfied.  Go the beginning to redraw.
        end
        %% 2. restrictions on the effects of the demand shock
        a2 = [(((imp1(2,1,1:5)) >= 0)) .* (imp1(2,2,1:5) >= 0).* (imp1(2,9,1:5) >= 0) ];
        if max(a2) == 0
                 continue;   %The restrictions are not satisfied.  Go the beginning to redraw.
        elseif (min(a2)==0)
            continue;    %The restrictions are not satisfied.  Go the beginning to redraw.
        end
        %% if everything is good save the draws
        mm = mm+1;
        irf0_boot(:,:,:,mm) = irf0_boottmp;
        irfcum_boot(:,:,:,mm) = imp1;
        clear imp1 irf0_boottmp
end
 



%%  calculcate median values and quantiles
    % calcuate the median values of all the impulse responses which passed
    % correct are the percentiles of the cumulated variablexs!
    for i = 1:M
        for k = 1:M
            for j = 1:s
                IMP1_cum(i,k,j) = median(irfcum_boot(i,k,j,:)); %median of cumulated impulses
                IMP1_cum_u(i,k,j) = quantile(irfcum_boot(i,k,j,:),0.9); %+1 std_deviation of cumulated impulses
                IMP1_cum_l(i,k,j) = quantile(irfcum_boot(i,k,j,:),1-0.9); %-1 std_deviation of cumulated impulses
            end
        end
    end
    %% plot the impulse responses

    save('C:\CodesJMCB15042013\ReplicaBuchEickmeierPrieto\IMP1_cum_VAR','IMP1_cum')
    save('C:\CodesJMCB15042013\ReplicaBuchEickmeierPrieto\IMP1_cum_VAR_u','IMP1_cum_u')
    save('C:\CodesJMCB15042013\ReplicaBuchEickmeierPrieto\IMP1_cum_VAR_l','IMP1_cum_l')
    % the aggregate variables
