function irf2dic = irfic(X,p,nboot,ww,horizon)

[T,N] = size(X); %N = 1
clear N;

irf0 = []; u0 = []; Bcorr = [];
regr = [];
for i = 0:p-1
    regr = [regr X(p-i:end-i-1,:)];
end
regr = [regr ones(cols(regr'),1)];
B1 = inv(regr'*regr)*regr'*X(p+1:end,:);
u = X(p+1:end,:)-regr*B1;
B = B1(1:end-1,:);

bias = [];
for m = 1:nboot  
 %   m
    c = ceil(rand(T-p,1)*(T-p));
    u_boot = u(c,:);
    Xpast_boot = [];
    for i = p:-1:1
        Xpast_boot = [Xpast_boot X(i,:)]; %eigentlich Anfangswerte randomisieren
    end
    Xpast_boot = [Xpast_boot 1];
   
    X_boot = X;
    for t = p+1:T
       X_boot(t,:) = Xpast_boot*B1 + u_boot(t-p,:);       
       Xpast_boot = [X_boot(t,:) Xpast_boot(:,1:end-1-1) ones(1,1)];
    end   
    
    z = X_boot;    
        clear X_boot; clear Xpast_boot;
    zpast = [];
    for kk = 1:p
        zpast = [zpast z(p-kk+1:end-kk,:)]; 
    end;
    zcurr = z(p+1:end,:);
    zpast = [zpast ones(T-p,1)];
    B_boot = inv(zpast'*zpast)*zpast'*zcurr;  
    bias(:,:,m) = B1 - B_boot; %rplusM+1 x rplusM x nboot
end
Bcorr = B1 - mean(bias,3);
clear bias B1 B_boot z zpast zcurr;
z = X;    
zpast = [];
for kk = 1:p
    zpast = [zpast X(p-kk+1:end-kk,:)]; 
end;
zcurr = z(p+1:end,:);
zpast = [zpast ones(T-p,1)];
uic = zcurr - zpast*Bcorr;
clear zcurr zpast;

%{
I = eye(1*p,1*p);
BBB = [Bcorr(1:1*p,:)';I(1:end-1,:)]; 
temp = eye(size(BBB));

irftemp = [];
irftemp(:,:,1) = temp;
for h = 1:horizon
   temp = BBB*temp; 
   irftemp(:,:,h+1) = temp;
end; 

for h = 0:horizon
    BB = irftemp(1:1,1:1,h+1)'; %B^h
    irf0(h+1,:)  = BB*WW;%*Loadingus';%*WW;  %*v'*WW is *C_hat   
end;
clear temp irftemp BBB; 
%}
irf2dic = []; 
for m = 1:nboot
    %m
    c = ceil(rand(T-p,1)*(T-p));
    u_boot = uic(c,:);
    Xpast_boot = [];
    for i = p:-1:1
        Xpast_boot=[Xpast_boot X(i,:)]; %eigentlich Anfangswerte randomisieren
    end
    Xpast_boot = [Xpast_boot 1];
    X_boot = X;
    for t = p+1:T
       X_boot(t,:) = Xpast_boot*Bcorr + u_boot(t-p,:);       
       Xpast_boot = [X_boot(t,:) Xpast_boot(:,1:end-1-1) ones(1,1)];
    end

    z = X_boot;
    clear X_boot; clear Xpast_boot;
        
    zpast = [];
    for kk = 1:p
        zpast = [zpast z(p-kk+1:end-kk,:)]; 
    end;
    zcurr = z(p+1:end,:);
    zpast = [zpast ones(T-p,1)];
    B_boot = inv(zpast'*zpast)*zpast'*zcurr;  
    u_boot = zcurr  - zpast*B_boot; 
        clear zcurr; clear zpast;
            
    I = eye(1*p,1*p);
    BBB = [B_boot(1:1*p,:)';I(1:end-1,:)];
    temp = eye(size(BBB));

    irftemp = [];
    irftemp(:,:,1) = temp;
    for h = 1:horizon
        temp = BBB*temp; 
        irftemp(:,:,h+1) = temp;
    end; 
    clear temp;
    
    for h = 0:horizon
        BB = irftemp(1:1,1:1,h+1)'; %B^h
        irf2dic(h+1,m) = BB*ww; %rplusM x rplusM
    end
       
end

irf2dic = irf2dic*std(uic); 
        