function [MM,WW,Ystand] = transfstandard(Y); %variance = 1, mean = 0, WW: standard deviations (for IRFs)

%input
    %Y: TxN matrix of data
%outputs
    %Ystand: Y with mean 0 and var 1
    %WW: matrix of standard deviations
    
[T,N] = size(Y);

Y0 = Y; 
Y1 = [];
Ystand = [];
for i=1:N 
    Y1(:,i) = Y(:,i)-nanmean(Y(:,i)');
    %Ystand(:,i) = Y(:,i)-nanmean(Y(:,i)');
   Ystand(:,i) = Y1(:,i)/nanstd(Y(:,i));   
%{    
    if i >= N-2 %if one wants to remove garch effects
        Ystand(:,i) = Y1(:,i)/nanstd(Y(:,i));   
    else
        [Coeff,Errors,LLF,Innovations,Sigmas,Summary] = garchfit(Y1(:,i));
        Ystand(:,i) = Y1(:,i)./Sigmas;
        Ystand(:,i) = Ystand(:,i)/std(Ystand(:,i)); %to guarantee that std = 1
    end
    %}

end
i = 1:1:N;
j = 1:1:N;
s = nanstd(Y0); 
m = N;
n = N;
WW = sparse(i,j,s,m,n);
%WW = nanstd(Y0); 
MM = nanmean(Y0);
    
